----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 16.03.2022 19:12:30
-- Design Name: 
-- Module Name: pwm_test - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;
--use IEEE.MATH_REAL.ALL;
--use IEEE.float_pkg.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity regler is
    Port ( clk : in STD_LOGIC;      --Clk -> Gibt abtastzeit vor
           prescaler : in signed(63 downto 0) := to_signed(1000000, 64);   -- prescaler fr Zeit 1000000
           w : in signed(63 downto 0) := (others => '0');     --Sollwert
           y : in signed(63 downto 0) := (others => '0');     --Istwert
           u : inout signed(63 downto 0) := (others => '0'); --Stellge
           KR : in signed(9 downto 0) := to_signed(1, 10);    -- Verstrkung
           T : in signed(9 downto 0) := to_signed(1000, 10);   -- Abtastzeit in us 1000us
           TV : signed(9 downto 0) := (others => '0');     -- Vorhaltezeit   fr Differenzierer interesannt
           TN : in signed(9 downto 0) := to_signed(1, 10);  -- Nachstellzeit
           regler_bruecken : in STD_LOGIC := '0');   -- u <= w
           
end regler;

architecture Behavioral of regler is


--signal stepWidth : integer := 1;   -- 10 us   spter berechnet aus Clk und Prescaler
--signal prescaler : signed(63 downto 0) := to_signed(1000000, 64);   -- prescaler fr Zeit 1000000


-- Parameter aus Sprungantwort etc.
--signal KR : integer := 1;           -- Verstrkung
--signal T : integer := 1000;      -- Abtastzeit in ns = 1ms = 1000000ns
--signal TV : integer := 0;     -- Vorhaltezeit   fr Differenzierer interesannt
--signal TN : integer := 10;    -- Nachstellzeit

-- Konstanten Reglerparameter
--signal a1 : integer ;
--signal b0 : integer;
--signal b1 : integer;
--signal b2 : integer;

--signal a1 : signed(63 downto 0) := to_signed(1, 64);
--signal b0 : signed(63 downto 0) := KR *(1 + TV / T);
--signal b1 : signed(63 downto 0) := -KR *(1 - T / TN + 2 * TV / T );
--signal b2 : signed(63 downto 0) := KR * TV/T;


--interne Signale signal
--signal u_k1 : integer := 0;  -- = uk-1 = u (wurde nicht gendert)
--signal e_k : integer := 0;     -- aktuelle Reglerdiffferenz
signal e_k1 : signed(63 downto 0) := to_signed(0, 64);    -- letzte       ""
signal e_k2 : signed(63 downto 0) := to_signed(0, 64);    -- vorletzte    ""


signal I_k : signed(147 downto 0) := to_signed(0, 148);  -- I-Anteil


-- signal u : integer := 100000; -- Eingangswert Strecke

--signal x : integer := 0; -- Ausgangssignal Strecke -> Stellgre



begin


process(clk)
 
    variable e_k : signed(63 downto 0) := to_signed(0, 64);     -- aktuelle Reglerabweichung
    --variable I_k : signed(148 downto 0) := to_signed(0, 64);     -- I-Anteil
    --variable I_k1 : integer := 0;    -- letzer I-Anteil
    variable u_var : signed(147 downto 0) := to_signed(0, 148);  
    
    variable uMax : signed(63 downto 0) :=  (63 =>'0', others=>'1');
    
    begin
             
        if rising_edge(clk) then
               
            -- Konstanten Reglerparameter
--            a1 <= 1;
--            b0 <= KR*(1+TV/T);
--            b1 <= -KR *(1 - T / TN + 2 * TV / T );
--            b2 <= KR * TV/T;
        
            
            e_k := w - y;   --Reglerdifferenzbilden
            
            
            -- PID-Regler ---------------------------------------                     
            --u <= (a1*u+b0*e_k+b1*e_k1+b2*e_k2)/1000;   --Stellgre u berechnen, PID-Regler
            
            --e_k2 <= e_k1;
            --e_k1 <= e_k;
            
            -- PI-Regler ----------------------------------------
            I_k <= I_k + T * 1 / TN * prescaler * e_k / prescaler;        -- I-Anteil berechnen
            u_var := KR * e_k + I_k;
            
            --Overflow abfangen
            if (u_var(147 downto 64) >  0) then               
                u <= uMax;
                
            elsif(u_var < to_signed(0, 64)) then
                u <= to_signed(0, 64);
            else
                u <= u_var(63 downto 0);
            end if;
            
            -----------------------------------------------------           
            
            if regler_bruecken = '1' then
                u <= w;   -- Regler berbrcken!    
            end if;
                                    
        end if;
        
end process;

--test
    
end Behavioral;
